/*	BSDI stats_inet6.h,v 2.3 1998/05/07 20:55:36 dab Exp	*/
/*----------------------------------------------------------------------
 inet.c:    netstat subroutines for AF_INET/AF_INET6.

 Originally from 4.4-Lite BSD.  Modifications to support IPv6 and IPsec
 copyright by Bao Phan, Randall Atkinson, & Dan McDonald, All Rights Reserved.
 All rights under this copyright are assigned to NRL.
----------------------------------------------------------------------*/
/*----------------------------------------------------------------------
#	@(#)COPYRIGHT	1.1 (NRL) 17 January 1995

COPYRIGHT NOTICE

All of the documentation and software included in this software
distribution from the US Naval Research Laboratory (NRL) are
copyrighted by their respective developers.

Portions of the software are derived from the Net/2 and 4.4 Berkeley
Software Distributions (BSD) of the University of California at
Berkeley and those portions are copyright by The Regents of the
University of California. All Rights Reserved.  The UC Berkeley
Copyright and License agreement is binding on those portions of the
software.  In all cases, the NRL developers have retained the original
UC Berkeley copyright and license notices in the respective files in
accordance with the UC Berkeley copyrights and license.

Portions of this software and documentation were developed at NRL by
various people.  Those developers have each copyrighted the portions
that they developed at NRL and have assigned All Rights for those
portions to NRL.  Outside the USA, NRL has copyright on some of the
software developed at NRL. The affected files all contain specific
copyright notices and those notices must be retained in any derived
work.

NRL LICENSE

NRL grants permission for redistribution and use in source and binary
forms, with or without modification, of the software and documentation
created at NRL provided that the following conditions are met:

1. All terms of the UC Berkeley copyright and license must be followed.
2. Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.
3. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.
4. All advertising materials mentioning features or use of this software
   must display the following acknowledgements:

	This product includes software developed by the University of
	California, Berkeley and its contributors.

	This product includes software developed at the Information
	Technology Division, US Naval Research Laboratory.

5. Neither the name of the NRL nor the names of its contributors
   may be used to endorse or promote products derived from this software
   without specific prior written permission.

THE SOFTWARE PROVIDED BY NRL IS PROVIDED BY NRL AND CONTRIBUTORS ``AS
IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL NRL OR
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

The views and conclusions contained in the software and documentation
are those of the authors and should not be interpreted as representing
official policies, either expressed or implied, of the US Naval
Research Laboratory (NRL).

----------------------------------------------------------------------*/


/*
 * Copyright (c) 1983, 1988, 1993
 *	The Regents of the University of California.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

static struct stats ipv6_stat[] = {
	{ { offsetof(struct ip6stat, ip6s_total) },
	  S_FMT1, FMT(FMT_Q " total pkt%s rcvd") },
	{ { offsetof(struct ip6stat, ip6s_delivered) },
	  S_FMT1, FMT(FMT_Q " pkt%s for this host") },
	{ { offsetof(struct ip6stat, ip6s_forward) },
	  S_FMT1, FMT(FMT_Q " pkt%s forwarded") },
	{ { offsetof(struct ip6stat, ip6s_redirectsent) },
	  S_FMT1, FMT(FMT_Q " redirect%s sent") },
	{ { offsetof(struct ip6stat, ip6s_cantforward) },
	  S_FMT1, FMT(FMT_Q " pkt%s not forwardable") },
	{ { offsetof(struct ip6stat, ip6s_toosmall) },
	  S_FMT_5, FMT(FMT_Q " w/size smaller than minimum") },
	{ { offsetof(struct ip6stat, ip6s_tooshort) },
	  S_FMT_5, FMT(FMT_Q " w/data size < data length") },
#if 0
	{ { offsetof(struct ip6stat, ip6s_noproto) },
	  S_FMT1, FMT(FMT_Q " pkt%s for unknown/unsupported proto") },
#endif
	{ { offsetof(struct ip6stat, ip6s_badvers) },
	  S_FMT_5, FMT(FMT_Q " w/invalid IP version number") },
	{ { offsetof(struct ip6stat, ip6s_badoptions) },
	  S_FMT_5, FMT(FMT_Q " w/bad options") },
	{ { offsetof(struct ip6stat, ip6s_fragments) },
	  S_FMT1, FMT(FMT_Q " fragment%s rcvd") },
	{ { offsetof(struct ip6stat, ip6s_fragdropped) },
	  S_FMT1, FMT(FMT_Q " fragment%s dropped (dup or no bufs)") },
	{ { offsetof(struct ip6stat, ip6s_fragtimeout) },
	  S_FMT1, FMT(FMT_Q " fragment%s dropped after timeout") },
	{ { offsetof(struct ip6stat, ip6s_fragoverflow) },
	  S_FMT1, FMT(FMT_Q " fragment%s exceeded limit") },
	{ { offsetof(struct ip6stat, ip6s_reassembled) },
	  S_FMT1, FMT(FMT_Q " pkt%s reassembled ok") },
	{ { offsetof(struct ip6stat, ip6s_localout) },
	  S_FMT1, FMT(FMT_Q " pkt%s sent from this host") },
	{ { offsetof(struct ip6stat, ip6s_rawout) },
	  S_FMT1, FMT(FMT_Q " pkt%s sent w/fabricated ip header") },
	{ { offsetof(struct ip6stat, ip6s_odropped) },
	  S_FMT1, FMT(FMT_Q " output pkt%s dropped: no bufs, etc.") },
	{ { offsetof(struct ip6stat, ip6s_noroute) },
	  S_FMT1, FMT(FMT_Q " output pkt%s dropped: no route") },
	{ { offsetof(struct ip6stat, ip6s_fragmented) },
	  S_FMT1, FMT(FMT_Q " output dgram%s fragmented") },
	{ { offsetof(struct ip6stat, ip6s_ofragments) },
	  S_FMT1, FMT(FMT_Q " fragment%s created") },
	{ { offsetof(struct ip6stat, ip6s_cantfrag) },
	  S_FMT1, FMT(FMT_Q " dgram%s that can't be fragmented") },
	{ { offsetof(struct ip6stat, ip6s_badoptions) },
	  S_FMT_5, FMT(FMT_Q " with bad options") },
	{ { offsetof(struct ip6stat, ip6s_badscope) },
	  S_FMT1, FMT(FMT_Q " packet%s that violated scope rules") },
	{ { offsetof(struct ip6stat, ip6s_notmember) },
	  S_FMT1, FMT(FMT_Q " multicast packet%s which we don't join") },
	{ { 0 /*dummy*/},
	  S_FMT_5, FMT("Input histogram:") },
#if 0
	{ { offsetof(struct ip6stat, ip6s_nxthist[0]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, FMT_I(FMT_Q " hop by hop"), 0 },
	{ { offsetof(struct ip6stat, ip6s_nxthist[1]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, FMT_I(FMT_Q " ICMP"), 1 },
	{ { offsetof(struct ip6stat, ip6s_nxthist[2]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, FMT_I(FMT_Q " IGMP"), 2 },
	{ { offsetof(struct ip6stat, ip6s_nxthist[4]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, FMT_I(FMT_Q " IP"), 4 },
	{ { offsetof(struct ip6stat, ip6s_nxthist[6]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, FMT_I(FMT_Q " TCP"), 6 },
	{ { offsetof(struct ip6stat, ip6s_nxthist[17]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, FMT_I(FMT_Q " UDP"), 17 },
	{ { offsetof(struct ip6stat, ip6s_nxthist[18]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 18 },
#endif
	{ { 0 /*dummy*/},
	  S_FMT_5, FMT("Mbuf statistics:") },
	{ { offsetof(struct ip6stat, ip6s_m1) },
	  S_FMT_5, FMT_I(FMT_Q " one mbuf") },
#if 0
	{ { offsetof(struct ip6stat, ip6s_m2m[0]) },
	  S_FMT_5|S_FMT_SKIPZERO, FMT_I(FMT_Q " two mbuf on interface 0") },
	{ { offsetof(struct ip6stat, ip6s_m2m[1]) },
	  S_FMT_5|S_FMT_SKIPZERO, FMT_I(FMT_Q " two mbuf on interface 1") },
	{ { offsetof(struct ip6stat, ip6s_m2m[2]) },
	  S_FMT_5|S_FMT_SKIPZERO, FMT_I(FMT_Q " two mbuf on interface 2") },
	{ { offsetof(struct ip6stat, ip6s_m2m[3]) },
	  S_FMT_5|S_FMT_SKIPZERO, FMT_I(FMT_Q " two mbuf on interface 3") },
	{ { offsetof(struct ip6stat, ip6s_m2m[4]) },
	  S_FMT_5|S_FMT_SKIPZERO, FMT_I(FMT_Q " two mbuf on interface 4") },
	{ { offsetof(struct ip6stat, ip6s_m2m[5]) },
	  S_FMT_5|S_FMT_SKIPZERO, FMT_I(FMT_Q " two mbuf on interface 5") },
	/* more... */
#endif
	{ { offsetof(struct ip6stat, ip6s_mext1) },
	  S_FMT_5, FMT_I(FMT_Q " one ext mbuf") },
	{ { offsetof(struct ip6stat, ip6s_mext2m) },
	  S_FMT_5, FMT_I(FMT_Q " two or more ext mbuf") },
	{ { offsetof(struct ip6stat, ip6s_exthdrtoolong) },
	  S_FMT1, FMT(FMT_Q " packet%s whose headers are not continuous") },
	{ { offsetof(struct ip6stat, ip6s_nogif) },
	  S_FMT1, FMT(FMT_Q " tunneling packet%s that can't find gif") },
	{ { offsetof(struct ip6stat, ip6s_toomanyhdr) },
	  S_FMT1, FMT(FMT_Q " packet%s discarded due to too many headers") },
#if 0
	{ { offsetof(struct ip6stat, ip6s_pulldown) },
	  S_FMT1, FMT(FMT_Q " call%s to m_pulldown") },
	{ { offsetof(struct ip6stat, ip6s_pulldown_alloc) },
	  S_FMT1, FMT(FMT_Q " mbuf allocation%s in m_pulldown") },
	{ { offsetof(struct ip6stat, ip6s_pulldown_copy) },
	  S_FMT1IES, FMT(FMT_Q " mbuf cop%s in m_pulldown") },
#endif
	{ { 0 } }
};

#if 0
static struct stats ESP_stat[] = {
	{ { offsetof(struct esp_stat_table, esp_sa_unavailable) },
	  S_FMT1, FMT(FMT_Q " unavailable ESP Security Associations") },
	{ { offsetof(struct esp_stat_table, esp_sa_invalid) },
	  S_FMT1, FMT(FMT_Q " invalid     ESP Security Associations") },
	{ { offsetof(struct esp_stat_table, esp_sa_delayed) },
	  S_FMT1, FMT(FMT_Q " delayed     ESP Security Associations") },
	{ { offsetof(struct esp_stat_table, esp_transport_sent) },
	  S_FMT1, FMT(FMT_Q " successful ESP transport-mode encryptions (pkts sent)") },
	{ { offsetof(struct esp_stat_table, esp_tunnel_sent) },
	  S_FMT1, FMT(FMT_Q " successful ESP tunnel-mode encryptions sent (pkts sent)") },
	{ { offsetof(struct esp_stat_table, esp_accepted) },
	  S_FMT1, FMT(FMT_Q " successful ESP decryptions performed (pkts accepted)") },
	{ { offsetof(struct esp_stat_table, esp_in_errs) },
	  S_FMT1, FMT(FMT_Q " failed ESP decryption%s (pkts dropped)") },
	{ { offsetof(struct esp_stat_table, esp_trans_out_errs) },
	  S_FMT1, FMT(FMT_Q " outgoing ESP transport-mode encryption%s failed (pkts dropped)") },
	{ { offsetof(struct esp_stat_table, esp_tunnel_out_errs) },
	  S_FMT1, FMT(FMT_Q " outgoing ESP tunnel-mode encryption%s failed (pkts dropped)") },
	{ { offsetof(struct esp_stat_table, esp_trans_missing) },
	  S_FMT1, FMT(FMT_Q " incoming pkts needed and were missing transport-mode ESP") },
	{ { offsetof(struct esp_stat_table, esp_tunnel_missing) },
	  S_FMT1, FMT(FMT_Q " incoming pkts needed and were missing tunnel-mode ESP") },
	{ { offsetof(struct esp_stat_table, esp_tunnel_spoof) },
	  S_FMT1, FMT(FMT_Q " received pkt%s attempted ESP tunnel spoof attack") },
	{ { 0 } }
};

static struct stats AH_stat[] = {
	{ { offsetof(struct ah_stat_table, ah_sa_unavailable) },
	  S_FMT1, FMT(FMT_Q " unavailable  AH Security Associations") },
	{ { offsetof(struct ah_stat_table, ah_sa_invalid) },
	  S_FMT1, FMT(FMT_Q " invalid      AH Security Associations") },
	{ { offsetof(struct ah_stat_table, ah_sa_delayed) },
	  S_FMT1, FMT(FMT_Q " delayed      AH Security Associations") },
	{ { offsetof(struct ah_stat_table, ah_sent) },
	  S_FMT1, FMT(FMT_Q " successful outgoing auth%s (pkts sent)") },
	{ { offsetof(struct ah_stat_table, ah_accepted) },
	  S_FMT1, FMT(FMT_Q " successful incoming auth%s (pkts accepted)") },
	{ { offsetof(struct ah_stat_table, ah_in_errs) },
	  S_FMT1, FMT(FMT_Q " failed incoming auth%s (pkts dropped)") },
	{ { offsetof(struct ah_stat_table, ah_out_errs) },
	  S_FMT1, FMT(FMT_Q " outgoing auth%s failed (pkts dropped)") },
	{ { offsetof(struct ah_stat_table, ah_missing) },
	  S_FMT1, FMT(FMT_Q " pkt%s needed and were missing AH") },
	{ { offsetof(struct ah_stat_table, ah_spoof) },
	  S_FMT1, FMT(FMT_Q " pkt%s attempted an AH tunnel spoof attack") },
	{ { 0 } }
};
#endif

static struct stats icmpv6_stat[] = {
	{ { offsetof(struct icmp6stat, icp6s_error) },
	  S_FMT1, FMT(FMT_Q " call%s to icmp_error") },

	{ { (u_long)&icmpv6s_sent },
	  S_FMT1|S_FMT_DIRECT, FMT(FMT_Q " pkt%s sent") },
	{ { offsetof(struct icmp6stat, icp6s_outhist[ICMP6_DST_UNREACH]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, FMT_I(FMT_Q " destination unreachable%s"), ICMP6_DST_UNREACH },
	{ { offsetof(struct icmp6stat, icp6s_outhist[ICMP6_PACKET_TOO_BIG]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, FMT_I(FMT_Q " pkt too big%s"), ICMP6_PACKET_TOO_BIG },
	{ { offsetof(struct icmp6stat, icp6s_outhist[ICMP6_TIME_EXCEEDED]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, FMT_I(FMT_Q " time exceeded%s"), ICMP6_TIME_EXCEEDED },
	{ { offsetof(struct icmp6stat, icp6s_outhist[ICMP6_PARAM_PROB]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, FMT_I(FMT_Q " parameter problem%s"), ICMP6_PARAM_PROB },
	{ { offsetof(struct icmp6stat, icp6s_outhist[ND_REDIRECT]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, FMT_I(FMT_Q " redirect%s"), ND_REDIRECT },
	{ { offsetof(struct icmp6stat, icp6s_outhist[5]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 5 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[6]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 6 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[7]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 7 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[8]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 8 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[9]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 9 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[10]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 10 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[11]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 11 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[12]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 12 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[13]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 13 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[14]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 14 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[15]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 15 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[16]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 16 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[17]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 17 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[18]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 18 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[19]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 19 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[20]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 20 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[21]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 21 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[22]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 22 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[23]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 23 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[24]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 24 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[25]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 25 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[26]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 26 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[27]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 27 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[28]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 28 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[29]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 29 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[30]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 30 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[31]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 31 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[32]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 32 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[33]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 33 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[34]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 34 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[35]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 35 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[36]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 36 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[37]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 37 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[38]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 38 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[39]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 39 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[40]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 40 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[41]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 41 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[42]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 42 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[43]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 43 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[44]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 44 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[45]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 45 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[46]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 46 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[47]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 47 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[48]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 48 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[49]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 49 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[50]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 50 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[51]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 51 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[52]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 52 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[53]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 53 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[54]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 54 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[55]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 55 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[56]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 56 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[57]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 57 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[58]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 58 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[59]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 59 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[60]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 60 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[61]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 61 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[62]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 62 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[63]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 63 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[64]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 64 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[65]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 65 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[66]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 66 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[67]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 67 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[68]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 68 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[69]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 69 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[70]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 70 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[71]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 71 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[72]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 72 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[73]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 73 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[74]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 74 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[75]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 75 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[76]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 76 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[77]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 77 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[78]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 78 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[79]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 79 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[80]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 80 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[81]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 81 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[82]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 82 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[83]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 83 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[84]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 84 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[85]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 85 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[86]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 86 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[87]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 87 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[88]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 88 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[89]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 89 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[90]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 90 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[91]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 91 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[92]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 92 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[93]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 93 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[94]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 94 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[95]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 95 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[96]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 96 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[97]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 97 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[98]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 98 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[99]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 99 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[100]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 100 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[101]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 101 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[102]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 102 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[103]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 103 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[104]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 104 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[105]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 105 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[106]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 106 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[107]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 107 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[108]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 108 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[109]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 109 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[110]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 110 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[111]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 111 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[112]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 112 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[113]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 113 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[114]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 114 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[115]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 115 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[116]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 116 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[117]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 117 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[118]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 118 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[119]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 119 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[120]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 120 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[121]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 121 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[122]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 122 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[123]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 123 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[124]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 124 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[125]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 125 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[126]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 126 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[127]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, NULL, 127 },
	{ { offsetof(struct icmp6stat, icp6s_outhist[ICMP6_ECHO_REQUEST]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, FMT_I(FMT_Q " echo request%s"), ICMP6_ECHO_REQUEST },
	{ { offsetof(struct icmp6stat, icp6s_outhist[ICMP6_ECHO_REPLY]) },
	  S_FMT1IES|S_FMT_FLAG1|S_FMT_SKIPZERO, FMT_I(FMT_Q " echo repl%s"), ICMP6_ECHO_REPLY },
	{ { offsetof(struct icmp6stat, icp6s_outhist[MLD6_LISTENER_QUERY]) },
	  S_FMT1IES|S_FMT_FLAG1|S_FMT_SKIPZERO, FMT_I(FMT_Q " group quer%s"), MLD6_LISTENER_QUERY },
	{ { offsetof(struct icmp6stat, icp6s_outhist[MLD6_LISTENER_REPORT]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, FMT_I(FMT_Q " group report%s"), MLD6_LISTENER_REPORT },
	{ { offsetof(struct icmp6stat, icp6s_outhist[MLD6_LISTENER_DONE]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, FMT_I(FMT_Q " group leave%s"), MLD6_LISTENER_DONE },
	{ { offsetof(struct icmp6stat, icp6s_outhist[ND_ROUTER_SOLICIT]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, FMT_I(FMT_Q " router solicit%s"), ND_ROUTER_SOLICIT },
	{ { offsetof(struct icmp6stat, icp6s_outhist[ND_ROUTER_ADVERT]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, FMT_I(FMT_Q " router advert%s"), ND_ROUTER_ADVERT },
	{ { offsetof(struct icmp6stat, icp6s_outhist[ND_NEIGHBOR_SOLICIT]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, FMT_I(FMT_Q " node solicit%s"), ND_NEIGHBOR_SOLICIT },
	{ { offsetof(struct icmp6stat, icp6s_outhist[ND_NEIGHBOR_ADVERT]) },
	  S_FMT1|S_FMT_FLAG1|S_FMT_SKIPZERO, FMT_I(FMT_Q " node advert%s"), ND_NEIGHBOR_ADVERT },

	{ { offsetof(struct icmp6stat, icp6s_badcode) },
	  S_FMT1, FMT(FMT_Q " msg%s w/bad code fields") },
	{ { offsetof(struct icmp6stat, icp6s_tooshort) },
	  S_FMT1, FMT(FMT_Q " msg%s < minimum length") },
	{ { offsetof(struct icmp6stat, icp6s_checksum) },
	  S_FMT1, FMT(FMT_Q " msg%s w/bad cksum") },
	{ { offsetof(struct icmp6stat, icp6s_badlen) },
	  S_FMT1, FMT(FMT_Q " msg%s w/bad length") },

	{ { (u_long)&icmpv6s_received },
	  S_FMT1|S_FMT_DIRECT, FMT(FMT_Q " pkt%s rcvd") },
	{ { offsetof(struct icmp6stat, icp6s_inhist[ICMP6_DST_UNREACH]) },
	  S_FMT_FLAG1, NULL, ICMP6_DST_UNREACH },
	{ { offsetof(struct icmp6stat, icp6s_inhist[ICMP6_PACKET_TOO_BIG]) },
	  S_FMT_FLAG1, NULL, ICMP6_PACKET_TOO_BIG },
	{ { offsetof(struct icmp6stat, icp6s_inhist[ICMP6_TIME_EXCEEDED]) },
	  S_FMT_FLAG1, NULL, ICMP6_TIME_EXCEEDED },
	{ { offsetof(struct icmp6stat, icp6s_inhist[ICMP6_PARAM_PROB]) },
	  S_FMT_FLAG1, NULL, ICMP6_PARAM_PROB },
	{ { offsetof(struct icmp6stat, icp6s_inhist[ND_REDIRECT]) },
	  S_FMT_FLAG1, NULL, ND_REDIRECT },
	{ { offsetof(struct icmp6stat, icp6s_inhist[5]) },
	  S_FMT_FLAG1, NULL, 5 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[5]) },
	  S_FMT_FLAG1, NULL, 6 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[5]) },
	  S_FMT_FLAG1, NULL, 7 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[5]) },
	  S_FMT_FLAG1, NULL, 8 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[5]) },
	  S_FMT_FLAG1, NULL, 9 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[10]) },
	  S_FMT_FLAG1, NULL, 10 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[11]) },
	  S_FMT_FLAG1, NULL, 11 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[12]) },
	  S_FMT_FLAG1, NULL, 12 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[13]) },
	  S_FMT_FLAG1, NULL, 13 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[14]) },
	  S_FMT_FLAG1, NULL, 14 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[15]) },
	  S_FMT_FLAG1, NULL, 15 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[16]) },
	  S_FMT_FLAG1, NULL, 16 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[17]) },
	  S_FMT_FLAG1, NULL, 17 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[18]) },
	  S_FMT_FLAG1, NULL, 18 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[19]) },
	  S_FMT_FLAG1, NULL, 19 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[20]) },
	  S_FMT_FLAG1, NULL, 20 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[21]) },
	  S_FMT_FLAG1, NULL, 21 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[22]) },
	  S_FMT_FLAG1, NULL, 22 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[23]) },
	  S_FMT_FLAG1, NULL, 23 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[24]) },
	  S_FMT_FLAG1, NULL, 24 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[25]) },
	  S_FMT_FLAG1, NULL, 25 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[26]) },
	  S_FMT_FLAG1, NULL, 26 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[27]) },
	  S_FMT_FLAG1, NULL, 27 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[28]) },
	  S_FMT_FLAG1, NULL, 28 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[29]) },
	  S_FMT_FLAG1, NULL, 29 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[30]) },
	  S_FMT_FLAG1, NULL, 30 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[31]) },
	  S_FMT_FLAG1, NULL, 31 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[32]) },
	  S_FMT_FLAG1, NULL, 32 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[33]) },
	  S_FMT_FLAG1, NULL, 33 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[34]) },
	  S_FMT_FLAG1, NULL, 34 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[35]) },
	  S_FMT_FLAG1, NULL, 35 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[36]) },
	  S_FMT_FLAG1, NULL, 36 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[37]) },
	  S_FMT_FLAG1, NULL, 37 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[38]) },
	  S_FMT_FLAG1, NULL, 38 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[39]) },
	  S_FMT_FLAG1, NULL, 39 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[40]) },
	  S_FMT_FLAG1, NULL, 40 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[41]) },
	  S_FMT_FLAG1, NULL, 41 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[42]) },
	  S_FMT_FLAG1, NULL, 42 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[43]) },
	  S_FMT_FLAG1, NULL, 43 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[44]) },
	  S_FMT_FLAG1, NULL, 44 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[45]) },
	  S_FMT_FLAG1, NULL, 45 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[46]) },
	  S_FMT_FLAG1, NULL, 46 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[47]) },
	  S_FMT_FLAG1, NULL, 47 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[48]) },
	  S_FMT_FLAG1, NULL, 48 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[49]) },
	  S_FMT_FLAG1, NULL, 49 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[50]) },
	  S_FMT_FLAG1, NULL, 50 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[51]) },
	  S_FMT_FLAG1, NULL, 51 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[52]) },
	  S_FMT_FLAG1, NULL, 52 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[53]) },
	  S_FMT_FLAG1, NULL, 53 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[54]) },
	  S_FMT_FLAG1, NULL, 54 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[55]) },
	  S_FMT_FLAG1, NULL, 55 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[56]) },
	  S_FMT_FLAG1, NULL, 56 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[57]) },
	  S_FMT_FLAG1, NULL, 57 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[58]) },
	  S_FMT_FLAG1, NULL, 58 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[59]) },
	  S_FMT_FLAG1, NULL, 59 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[60]) },
	  S_FMT_FLAG1, NULL, 60 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[61]) },
	  S_FMT_FLAG1, NULL, 61 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[62]) },
	  S_FMT_FLAG1, NULL, 62 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[63]) },
	  S_FMT_FLAG1, NULL, 63 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[64]) },
	  S_FMT_FLAG1, NULL, 64 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[65]) },
	  S_FMT_FLAG1, NULL, 65 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[66]) },
	  S_FMT_FLAG1, NULL, 66 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[67]) },
	  S_FMT_FLAG1, NULL, 67 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[68]) },
	  S_FMT_FLAG1, NULL, 68 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[69]) },
	  S_FMT_FLAG1, NULL, 69 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[70]) },
	  S_FMT_FLAG1, NULL, 70 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[71]) },
	  S_FMT_FLAG1, NULL, 71 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[72]) },
	  S_FMT_FLAG1, NULL, 72 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[73]) },
	  S_FMT_FLAG1, NULL, 73 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[74]) },
	  S_FMT_FLAG1, NULL, 74 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[75]) },
	  S_FMT_FLAG1, NULL, 75 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[76]) },
	  S_FMT_FLAG1, NULL, 76 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[77]) },
	  S_FMT_FLAG1, NULL, 77 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[78]) },
	  S_FMT_FLAG1, NULL, 78 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[79]) },
	  S_FMT_FLAG1, NULL, 79 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[80]) },
	  S_FMT_FLAG1, NULL, 80 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[81]) },
	  S_FMT_FLAG1, NULL, 81 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[82]) },
	  S_FMT_FLAG1, NULL, 82 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[83]) },
	  S_FMT_FLAG1, NULL, 83 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[84]) },
	  S_FMT_FLAG1, NULL, 84 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[85]) },
	  S_FMT_FLAG1, NULL, 85 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[86]) },
	  S_FMT_FLAG1, NULL, 86 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[87]) },
	  S_FMT_FLAG1, NULL, 87 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[88]) },
	  S_FMT_FLAG1, NULL, 88 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[89]) },
	  S_FMT_FLAG1, NULL, 89 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[90]) },
	  S_FMT_FLAG1, NULL, 90 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[91]) },
	  S_FMT_FLAG1, NULL, 91 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[92]) },
	  S_FMT_FLAG1, NULL, 92 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[93]) },
	  S_FMT_FLAG1, NULL, 93 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[94]) },
	  S_FMT_FLAG1, NULL, 94 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[95]) },
	  S_FMT_FLAG1, NULL, 95 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[96]) },
	  S_FMT_FLAG1, NULL, 96 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[97]) },
	  S_FMT_FLAG1, NULL, 97 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[98]) },
	  S_FMT_FLAG1, NULL, 98 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[99]) },
	  S_FMT_FLAG1, NULL, 99 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[100]) },
	  S_FMT_FLAG1, NULL, 100 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[101]) },
	  S_FMT_FLAG1, NULL, 101 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[102]) },
	  S_FMT_FLAG1, NULL, 102 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[103]) },
	  S_FMT_FLAG1, NULL, 103 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[104]) },
	  S_FMT_FLAG1, NULL, 104 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[105]) },
	  S_FMT_FLAG1, NULL, 105 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[106]) },
	  S_FMT_FLAG1, NULL, 106 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[107]) },
	  S_FMT_FLAG1, NULL, 107 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[108]) },
	  S_FMT_FLAG1, NULL, 108 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[109]) },
	  S_FMT_FLAG1, NULL, 109 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[110]) },
	  S_FMT_FLAG1, NULL, 110 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[111]) },
	  S_FMT_FLAG1, NULL, 111 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[112]) },
	  S_FMT_FLAG1, NULL, 112 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[113]) },
	  S_FMT_FLAG1, NULL, 113 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[114]) },
	  S_FMT_FLAG1, NULL, 114 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[115]) },
	  S_FMT_FLAG1, NULL, 115 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[116]) },
	  S_FMT_FLAG1, NULL, 116 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[117]) },
	  S_FMT_FLAG1, NULL, 117 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[118]) },
	  S_FMT_FLAG1, NULL, 118 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[119]) },
	  S_FMT_FLAG1, NULL, 119 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[120]) },
	  S_FMT_FLAG1, NULL, 120 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[121]) },
	  S_FMT_FLAG1, NULL, 121 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[122]) },
	  S_FMT_FLAG1, NULL, 122 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[123]) },
	  S_FMT_FLAG1, NULL, 123 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[124]) },
	  S_FMT_FLAG1, NULL, 124 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[125]) },
	  S_FMT_FLAG1, NULL, 125 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[126]) },
	  S_FMT_FLAG1, NULL, 126 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[127]) },
	  S_FMT_FLAG1, NULL, 127 },
	{ { offsetof(struct icmp6stat, icp6s_inhist[ICMP6_ECHO_REQUEST]) },
	  S_FMT_FLAG1, NULL, ICMP6_ECHO_REQUEST },
	{ { offsetof(struct icmp6stat, icp6s_inhist[ICMP6_ECHO_REPLY]) },
	  S_FMT_FLAG1, NULL, ICMP6_ECHO_REPLY },
	{ { offsetof(struct icmp6stat, icp6s_inhist[MLD6_LISTENER_QUERY]) },
	  S_FMT_FLAG1, NULL, MLD6_LISTENER_QUERY },
	{ { offsetof(struct icmp6stat, icp6s_inhist[MLD6_LISTENER_REPORT]) },
	  S_FMT_FLAG1, NULL, MLD6_LISTENER_REPORT },
	{ { offsetof(struct icmp6stat, icp6s_inhist[MLD6_LISTENER_DONE]) },
	  S_FMT_FLAG1, NULL, MLD6_LISTENER_DONE },
	{ { offsetof(struct icmp6stat, icp6s_inhist[ND_ROUTER_SOLICIT]) },
	  S_FMT_FLAG1, NULL, ND_ROUTER_SOLICIT },
	{ { offsetof(struct icmp6stat, icp6s_inhist[ND_ROUTER_ADVERT]) },
	  S_FMT_FLAG1, NULL, ND_ROUTER_ADVERT },
	{ { offsetof(struct icmp6stat, icp6s_inhist[ND_NEIGHBOR_SOLICIT]) },
	  S_FMT_FLAG1, NULL, ND_NEIGHBOR_SOLICIT },
	{ { offsetof(struct icmp6stat, icp6s_inhist[ND_NEIGHBOR_ADVERT]) },
	  S_FMT_FLAG1, NULL, ND_NEIGHBOR_ADVERT },

	{ { offsetof(struct icmp6stat, icp6s_reflect) },
	  S_FMT1, FMT(FMT_Q " message response%s generated") },

	{ { 0 } }
};

static void
icmpv6_stat_init(void) {
	struct stats *sp;
	char buf[LINE_MAX];
	const char *msgs[ICMP6_MAXTYPE + 1];
	u_int flags[ICMP6_MAXTYPE + 1];

	memset(msgs, 0, sizeof(msgs));
	memset(flags, 0, sizeof(flags));
	for (sp = icmpv6_stat; sp->s_flags != 0; sp++) {
		if ((sp->s_flags & S_FMT_FLAG1) == 0)
			continue;
		if (sp->s_fmt != NULL) {
			msgs[sp->s_aux] = sp->s_fmt;
			flags[sp->s_aux] = sp->s_flags;
		} else if (msgs[sp->s_aux] == NULL) {
			(void)snprintf(buf, sizeof(buf), FMT_I("%s type #%u"),
			    FMT_Q, sp->s_aux);
			msgs[sp->s_aux] = sp->s_fmt = strdup(buf);
			flags[sp->s_aux] = sp->s_flags;
		} else {
			sp->s_fmt = msgs[sp->s_aux];
			sp->s_flags = flags[sp->s_aux];
		}
		sp->s_aux = 0;
	}
}
